Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 977)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 978)
@@ -4,5 +4,8 @@
 ! Current revisions:
 ! -----------------
-!
+! km_damp_x and km_damp_y removed in calls of diffusion_u and diffusion_v
+! add ptdf_x, ptdf_y for damping the potential temperature at the inflow
+! boundary in case of non-cyclic lateral boundaries
+! Bugfix: first thread index changes for WS-scheme at the inflow
 !
 ! Former revisions:
@@ -201,9 +204,9 @@
           ENDIF
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend, u_m,   &
-                               usws_m, uswst_m, v_m, w_m )
+             CALL diffusion_u( i, j, ddzu, ddzw, km_m, tend, u_m, usws_m, &
+                               uswst_m, v_m, w_m )
           ELSE
-             CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, usws, &
-                               uswst, v, w )
+             CALL diffusion_u( i, j, ddzu, ddzw, km, tend, u, usws, uswst, &
+                               v, w )
           ENDIF
           CALL coriolis( i, j, 1 )
@@ -289,9 +292,9 @@
           ENDIF
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend, u_m, &
-                               v_m, vsws_m, vswst_m, w_m )
+             CALL diffusion_v( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
+                               vsws_m, vswst_m, w_m )
           ELSE
-             CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v,  &
-                               vsws, vswst, w )
+             CALL diffusion_v( i, j, ddzu, ddzw, km, tend, u, v, vsws, &
+                               vswst, w )
           ENDIF
           CALL coriolis( i, j, 2 )
@@ -373,9 +376,7 @@
           ENDIF
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x, km_damp_y,  &
-                               tend, u_m, v_m, w_m )
+             CALL diffusion_w( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, w_m )
           ELSE
-             CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y,    &
-                               tend, u, v, w )
+             CALL diffusion_w( i, j, ddzu, ddzw, km, tend, u, v, w )
           ENDIF
           CALL coriolis( i, j, 3 )
@@ -524,8 +525,9 @@
              DO  k = nzb_s_inner(j,i)+1, nzt
                 pt_p(k,j,i) = ( 1 - sat ) * pt_m(k,j,i) + sat * pt(k,j,i) + &
-                              dt_3d * (                                           &
+                              dt_3d * (                                        &
                                        sbt * tend(k,j,i) + tsc(3) * tpt_m(k,j,i) &
-                                      ) -                                         &
-                              tsc(5) * rdf_sc(k) * ( pt(k,j,i) - pt_init(k) )
+                                      ) - &
+                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
+                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
              ENDDO
 
@@ -983,5 +985,5 @@
              IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_mom )  THEN
-                   IF ( outflow_l .AND. i_omp_start == nxl )  THEN 
+                   IF ( ( inflow_l .OR. outflow_l ) .AND. i_omp_start == nxl )  THEN 
 !                     CALL local_diss( i, j, u)    ! dissipation control
                       CALL advec_u_ws( i, j, i_omp_start + 1, tn )
@@ -997,9 +999,9 @@
              IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
              THEN
-                CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend,  &
-                                  u_m, usws_m, uswst_m, v_m, w_m )
-             ELSE
-                CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, &
-                                  usws, uswst, v, w )
+                CALL diffusion_u( i, j, ddzu, ddzw, km_m, tend,  u_m, &
+                                  usws_m, uswst_m, v_m, w_m )
+             ELSE
+                CALL diffusion_u( i, j, ddzu, ddzw, km, tend, u, usws, &
+                                  uswst, v, w )
              ENDIF
              CALL coriolis( i, j, 1 )
@@ -1066,9 +1068,9 @@
              IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
              THEN
-                CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend,     &
-                                  u_m, v_m, vsws_m, vswst_m, w_m )
-             ELSE
-                CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v, &
-                                  vsws, vswst, w )
+                CALL diffusion_v( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
+                                  vsws_m, vswst_m, w_m )
+             ELSE
+                CALL diffusion_v( i, j, ddzu, ddzw, km, tend, u, v, vsws, &
+                                  vswst, w )
              ENDIF
              CALL coriolis( i, j, 2 )
@@ -1130,9 +1132,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
           THEN
-             CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x,          &
-                               km_damp_y, tend, u_m, v_m, w_m )
+             CALL diffusion_w( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
+                               w_m )
           ELSE
-             CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y, &
-                               tend, u, v, w )
+             CALL diffusion_w( i, j, ddzu, ddzw, km, tend, u, v, w )
           ENDIF
           CALL coriolis( i, j, 3 )
@@ -1240,6 +1241,7 @@
                               dt_3d * (                                        &
                                   tsc(2) * tend(k,j,i) + tsc(3) * tpt_m(k,j,i) &
-                                      ) -                                      &
-                              tsc(5) * rdf_sc(k) * ( pt(k,j,i) - pt_init(k) )
+                                      ) - &
+                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
+                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
              ENDDO
 
@@ -1540,8 +1542,8 @@
     ENDIF
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_u( ddzu, ddzw, km_m, km_damp_y, tend, u_m, usws_m, &
-                         uswst_m, v_m, w_m )
+       CALL diffusion_u( ddzu, ddzw, km_m, tend, u_m, usws_m, uswst_m, &
+                         v_m, w_m )
     ELSE
-       CALL diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, uswst, v, w )
+       CALL diffusion_u( ddzu, ddzw, km, tend, u, usws, uswst, v, w )
     ENDIF
     CALL coriolis( 1 )
@@ -1634,8 +1636,8 @@
     ENDIF
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_v( ddzu, ddzw, km_m, km_damp_x, tend, u_m, v_m, vsws_m, &
-                         vswst_m, w_m )
+       CALL diffusion_v( ddzu, ddzw, km_m, tend, u_m, v_m, vsws_m, vswst_m, &
+                         w_m )
     ELSE
-       CALL diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, vswst, w )
+       CALL diffusion_v( ddzu, ddzw, km, tend, u, v, vsws, vswst, w )
     ENDIF
     CALL coriolis( 2 )
@@ -1725,8 +1727,7 @@
     ENDIF
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_w( ddzu, ddzw, km_m, km_damp_x, km_damp_y, tend, u_m, &
-                         v_m, w_m )
+       CALL diffusion_w( ddzu, ddzw, km_m, tend, u_m, v_m, w_m )
     ELSE
-       CALL diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, w )
+       CALL diffusion_w( ddzu, ddzw, km, tend, u, v, w )
     ENDIF
     CALL coriolis( 3 )
@@ -1877,9 +1878,10 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = ( 1 - sat ) * pt_m(k,j,i) + sat * pt(k,j,i) +       &
-                              dt_3d * (                                           &
-                                       sbt * tend(k,j,i) + tsc(3) * tpt_m(k,j,i) &
-                                      ) -                                         &
-                              tsc(5) * rdf_sc(k) * ( pt(k,j,i) - pt_init(k) )
+                pt_p(k,j,i) = ( 1 - sat ) * pt_m(k,j,i) + sat * pt(k,j,i) +    &
+                              dt_3d * (                                        &
+                                       sbt * tend(k,j,i) + tsc(3) * tpt_m(k,j,i)&
+                                      ) - &
+                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
+                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/read_3d_binary.f90	(revision 977)
+++ /palm/trunk/SOURCE/read_3d_binary.f90	(revision 978)
@@ -4,4 +4,5 @@
 ! Current revisions:
 ! -----------------
+! +z0h, z0h_av
 !
 ! Former revisions:
@@ -963,4 +964,17 @@
                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'z0h' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   z0h(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'z0h_av' )
+                   IF ( .NOT. ALLOCATED( z0h_av ) )  THEN
+                      ALLOCATE( z0h_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   z0h_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE DEFAULT
                    WRITE( message_string, * ) 'unknown field named "', &
Index: /palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/read_var_list.f90	(revision 977)
+++ /palm/trunk/SOURCE/read_var_list.f90	(revision 978)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! ------------------
-!
+! -km_damp_max, outflow_damping_width
+! +pt_damping_factor, pt_damping_width
+! +z0h_factor
 !
 ! Former revisions:
@@ -385,6 +387,4 @@
           CASE ( 'km_constant' )
              READ ( 13 )  km_constant
-          CASE ( 'km_damp_max' )
-             READ ( 13 )  km_damp_max
           CASE ( 'lad' )
              READ ( 13 )  lad
@@ -446,6 +446,4 @@
           CASE ( 'omega_sor' )
              READ ( 13 )  omega_sor
-          CASE ( 'outflow_damping_width' )
-             READ ( 13 )  outflow_damping_width
           CASE ( 'output_for_t0' )
              READ (13)    output_for_t0
@@ -476,4 +474,8 @@
           CASE ( 'psolver' )
              READ ( 13 )  psolver
+          CASE ( 'pt_damping_factor' )
+             READ ( 13 )  pt_damping_factor
+          CASE ( 'pt_damping_width' )
+             READ ( 13 )  pt_damping_width
           CASE ( 'pt_init' )
              READ ( 13 )  pt_init
@@ -684,4 +686,6 @@
           CASE ( 'w_max_ijk' )
              READ ( 13 )  w_max_ijk
+          CASE ( 'z0h_factor' )
+             READ ( 13 )  z0h_factor
 
           CASE DEFAULT
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 977)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 978)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +z0h*
 !
 ! Former revisions:
@@ -227,4 +227,10 @@
                 ENDIF
                 z0_av = 0.0
+
+             CASE ( 'z0h*' )
+                IF ( .NOT. ALLOCATED( z0h_av ) )  THEN
+                   ALLOCATE( z0h_av(nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                z0h_av = 0.0
 
              CASE DEFAULT
@@ -494,4 +500,11 @@
              ENDDO
 
+          CASE ( 'z0h*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   z0h_av(j,i) = z0h_av(j,i) + z0h(j,i)
+                ENDDO
+             ENDDO
+
           CASE DEFAULT
 !
Index: /palm/trunk/SOURCE/timestep.f90
===================================================================
--- /palm/trunk/SOURCE/timestep.f90	(revision 977)
+++ /palm/trunk/SOURCE/timestep.f90	(revision 978)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! restriction of the outflow damping layer in the diffusion criterion removed
 !
 ! Former revisions:
@@ -185,14 +185,4 @@
        dt_diff = dt_diff_l
 #endif
-
-!
-!--    In case of non-cyclic lateral boundaries, the diffusion time step
-!--    may be further restricted by the lateral damping layer (damping only
-!--    along x and y)
-       IF ( .NOT. bc_lr_cyc )  THEN
-          dt_diff = MIN( dt_diff, 0.125 * dx2 / ( km_damp_max + 1E-20 ) )
-       ELSEIF ( .NOT. bc_ns_cyc )  THEN
-          dt_diff = MIN( dt_diff, 0.125 * dy2 / ( km_damp_max + 1E-20 ) )
-       ENDIF
 
 !
Index: /palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/write_3d_binary.f90	(revision 977)
+++ /palm/trunk/SOURCE/write_3d_binary.f90	(revision 978)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! +z0h, z0h_av
 !
 ! Former revisions:
@@ -298,4 +298,8 @@
        WRITE ( 14 )  'z0_av               ';  WRITE ( 14 )  z0_av
     ENDIF
+    WRITE ( 14 )  'z0h                 ';  WRITE ( 14 )  z0h
+    IF ( ALLOCATED( z0h_av ) )  THEN
+       WRITE ( 14 )  'z0h_av              ';  WRITE ( 14 )  z0h_av
+    ENDIF
 
 !
Index: /palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/write_var_list.f90	(revision 977)
+++ /palm/trunk/SOURCE/write_var_list.f90	(revision 978)
@@ -4,5 +4,7 @@
 ! Current revisions:
 ! -----------------
-!
+! -km_damp_max, outflow_damping_width
+! +pt_damping_factor, pt_damping_width
+! +z0h_factor
 !
 ! Former revisions:
@@ -300,6 +302,4 @@
     WRITE ( 14 )  'km_constant                   '
     WRITE ( 14 )  km_constant
-    WRITE ( 14 )  'km_damp_max                   '
-    WRITE ( 14 )  km_damp_max
     WRITE ( 14 )  'lad                           '
     WRITE ( 14 )  lad
@@ -358,6 +358,4 @@
     WRITE ( 14 )  'omega_sor                     '
     WRITE ( 14 )  omega_sor
-    WRITE ( 14 )  'outflow_damping_width         '
-    WRITE ( 14 )  outflow_damping_width
     WRITE ( 14 )  'output_for_t0                 '
     WRITE ( 14 )  output_for_t0
@@ -388,4 +386,8 @@
     WRITE ( 14 )  'psolver                       '
     WRITE ( 14 )  psolver
+    WRITE ( 14 )  'pt_damping_factor             '
+    WRITE ( 14 )  pt_damping_factor
+    WRITE ( 14 )  'pt_damping_width              '
+    WRITE ( 14 )  pt_damping_width
     WRITE ( 14 )  'pt_init                       '
     WRITE ( 14 )  pt_init
@@ -596,4 +598,6 @@
     WRITE ( 14 )  'w_max_ijk                     '
     WRITE ( 14 )  w_max_ijk
+    WRITE ( 14 )  'z0h_factor                    '
+    WRITE ( 14 )  z0h_factor
 
 !
